<?php
/*
Plugin Name: Ads-WordPress
Plugin URI: http://ili.com.ua/wordpress/ads-wordpress
Description: Ads for WordPress
Author: Stepanov Yuri (stur)
Version: 3.0.17
Author URI: http://ili.com.ua/wordpress/
*/

include_once 'ads_functions.php';
include_once "ads_config.php";
include_once "ads_widgets.php";
@include_once "ads_pay.php";   // подключение платного модуля если он есть
$ads_options = get_option($ads_config['opt_name']);
if ( !is_array($ads_options) ) $ads_options = array();

load_plugin_textdomain('ads-wordpress', PLUGINDIR.'/'.dirname(plugin_basename(__FILE__)).'/lang/');



class ads_form_handler
{ // BEGIN class ads_form_handler
	// variables
	var $EDIT;  // флаг редактирования
	var $AdsFormEdit = false;   // флаг - мы на странице редактирования
  	var $wp_error;     // объект  WP_Error
  	var $ads_fields_form;
	var $name_template = false; // имя файла шаблона формы
	// constructor
function ads_form_handler()
{ // BEGIN constructor

} // END constructor
/*
	основной алгоритм обработчика
*/
function ads_main($content)
{
    // если нет тега <!--AdsForm-->  или <!--AdsFormEdit-->  выходим ничего не меняя
    if(!preg_match('~<!--AdsForm(Edit)?-->~i',$content,$match)) return $content;
    $this->content = $content;
    if($match[1]) $this->AdsFormEdit = true; // форма редактирования
    // проверяем если включенна опция только для зарегистрированных пользователей
    if( $str = $this->check_user_status() ) return $str;
	//  подготовка к запуску

	$this->init();

	//  отфильтровываем лишние поля
    $this->filter_fields_form();

	// получаем значение кнопки Action
    $this->action = ($_POST['ADS_ACTION']) ? @key($_POST['ADS_ACTION']) : @key($_GET['ADS_ACTION']);
    //echo '<pre>'; print_r($this->action); echo '</pre>';
	switch ($this->action) {
        default:   //  Print form
            if($this->AdsFormEdit)
                $this->login_form();
            else{
                    if(! $this->can_new_post() ){
                       $this->print_msg('no_new_post');
                    }else{
                        $this->print_form();
                    }

                }
        break;
        case 'PARSE':
        case 'UPDATE':
        case 'PUBLISH':
        case 'SAVE':
            // если это новый пост проверяем можно ли создать его и выходим
            if(empty($_REQUEST['ID']) and !$this->can_new_post()){
               $this->print_msg('no_new_post');
               break;
            }
            //  проверяем каптчу
            if( !$this->check_captcha() ){
                $this->print_form();
                break;
            }

            $this->pre_format();
            if($this->check_form()){
                $this->set_status();
                $this->save_form();
                $this->send_mail();
            }
            $this->upload();
            $this->print_form();
        break;
        case 'EDIT':
        case 'LOGIN':
            if($this->ads_login()){
                $this->load_data();
                $this->print_form();
            }
            else
                $this->login_form();
        break;
        case 'LOGIN_DELETE':
            if($this->ads_login()){
                $this->load_data();
            }
            else
                $this->login_form();

        case 'DELETE':
            if($this->can_delete()){
                $this->delete();
            }else{
                $this->login_form();
            }
        break;
        case 'DELETE_FILE':
            if($this->can_delete()){
            	$this->file_delete();
			}
			$this->print_form();
		break;
		case 'ROTATE_LEFT':
		case 'ROTATE_RIGHT':
            if($this->can_delete()){
            	$this->file_rotate();
			}
			$this->print_form();
		break;
    }
    return $this->content;
}


/*
	инициализация  данных массивов и переменных
*/
function init()
{
    session_name ('ads');
    session_start();
    include_once dirname(__FILE__).'/FormPersister.php';
    $arr = get_class_methods ('HTML_SemiParser');
    if(in_array('makeCallbackIgnore',$arr)) $this->action = -1;
	// комбинируем массив-фильтр разрешонных полей
    $this->comb_fields_form();
    $this->wp_error = new WP_Error;
	// получаем текущий шаблон формы
    $this->name_template = $this->category_template($_REQUEST['ads_basecat']);
    //подключаем шаюлон формы чтобы заработали локальные функции-фильтры
    // весь вывод прячем
    if( $this->name_template ){
      ob_start();
      global $ads_config;
      include $ads_config['dir_template'].$this->name_template;
      ob_end_clean();
    }
}

/*
	предварительная обработка полей записи
сначала форматируем потом проверяем
*/
function pre_format(){
    global  $ads_options;
  // просто убираем переслеширование   блядь и удаляем hnml теги если надо  <b>afgaefasdfasd</b>
	foreach ($_REQUEST as $key=>$value) {
		if(is_string($value)){
			$value =	@str_replace(array("\'",'\"'),array("'",'"'),$value);
            if(!$ads_options['ads_nostrip_tags']){
                $value = strip_tags( $value, $ads_options['ads_strip_tags']);
            }
            $_REQUEST[$key] = $value;
		}
	}
    $_REQUEST['post_content'] = preg_replace('~([\w\dА-Яа-я])([\.\,\!\;\:\-\/\+\_]+)([\w\dА-Яа-я])~u','\1\2\3',$_REQUEST['post_content']);
    $_REQUEST['post_title'] = preg_replace('~([\w\dА-Яа-я])([\.\,\!\;\:\-\/\+\_]+)([\w\dА-Яа-я])~u','\1\2\3',$_REQUEST['post_title']);
}
/*
	печатает кнопки управления
	$return =0  print buttons
    $return = 1  return html text
*/
function print_buttons($return = 0){
    global $user_ID, $ads_options;
    if(!$_REQUEST['post_status'] AND $_REQUEST['ID']){
		$_REQUEST['post_status'] = get_post_status($_REQUEST['ID']);
	}
    if(current_user_can( 'edit_others_posts', $user_ID ))
        if($_REQUEST['post_status'] == 'publish'){
            $html = "<input type=\"submit\" name=\"ADS_ACTION[UPDATE]\" value=\"".__('Update','ads-wordpress')."\" />";
            $html .= "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
        }else{
            $html = "<input type=\"submit\" name=\"ADS_ACTION[PUBLISH]\" value=\"".__('Publish','ads-wordpress')."\" />";
            $html .= "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
        }
    elseif( current_user_can( 'edit_posts', $user_ID ) )
        if($ads_options['ads_post_status'] == 'publish'){
            if($_REQUEST['post_status'] == 'publish'){
                $html = "<input type=\"submit\" name=\"ADS_ACTION[UPDATE]\" value=\"".__('Update','ads-wordpress')."\" />";
                $html .= "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
            }else{
                $html = "<input type=\"submit\" name=\"ADS_ACTION[PUBLISH]\" value=\"".__('Publish','ads-wordpress')."\" />";
                $html .= "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
            }
        }elseif($ads_options['ads_post_status'] == 'pending'){
            if($_REQUEST['post_status'] == 'pending' OR $_REQUEST['post_status'] == 'publish'){
                $html = "<input type=\"submit\" name=\"ADS_ACTION[UPDATE]\" value=\"".__('Update','ads-wordpress')."\" />";
                $html .= "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
            }else{
                $html = "<input type=\"submit\" name=\"ADS_ACTION[PUBLISH]\" value=\"".__('Send to moderation','ads-wordpress')."\" />";
                $html .= "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
            }
        }else{
            $html = "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
        }

    else {
        if($ads_options['ads_post_status'] == 'publish')
            if($_REQUEST['post_status'] == 'publish')
                $html = "<input type=\"submit\" name=\"ADS_ACTION[UPDATE]\" value=\"".__('Update','ads-wordpress')."\" />";
            else
                $html = "<input type=\"submit\" name=\"ADS_ACTION[PUBLISH]\" value=\"".__('Publish','ads-wordpress')."\" />";
        elseif($ads_options['ads_post_status'] == 'pending')
            $html = "<input type=\"submit\" name=\"ADS_ACTION[PUBLISH]\" value=\"".__('Send to moderation','ads-wordpress')."\" />";
        else
            $html = "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
    }

    $html .= "<input type=\"submit\" name=\"ADS_ACTION[DELETE]\" value=\"".__('Delete','ads-wordpress')."\" />";
    if($return)  return $html;
    else echo $html;
}
/*
	устанавливает статус записи
*/
function set_status(){
    global $user_ID, $ads_options;
    if(current_user_can( 'edit_others_posts', $user_ID )){ // если у юзера права редактора
        if($this->action == 'PUBLISH' OR  $this->action == 'UPDATE')
            $_REQUEST['post_status'] =  'publish';
        elseif($this->action == 'SAVE')
            $_REQUEST['post_status'] =  'draft';
    }
    elseif( current_user_can( 'edit_posts', $user_ID ) ) // просто автор
        if($ads_options['ads_post_status'] == 'publish'){
            if($this->action == 'PUBLISH' OR  $this->action == 'UPDATE')
                $_REQUEST['post_status'] =  'publish';
            elseif($this->action == 'SAVE')
                $_REQUEST['post_status'] =  'draft';
        }elseif($ads_options['ads_post_status'] == 'pending'){
            if($this->action == 'PUBLISH' OR  $this->action == 'UPDATE')
                $_REQUEST['post_status'] =  'pending';
            elseif($this->action == 'SAVE')
                $_REQUEST['post_status'] =  'draft';
        }else{
            $_REQUEST['post_status'] =  'draft';
        }
    else{
        // если нет то статус устанавливаем в соответствии с настройками плагина
        $_REQUEST['post_status'] = $ads_options['ads_post_status'];
    }
    //echo '<pre>set_status():'; print_r($this->action.' => '.$_REQUEST['post_status']); echo '</pre>';
}
/*
	устанавливает статус комментариев для записи
*/
function set_comments(){
    global $ads_options;

	if(($ads_options['ads_comments']) == 'optional') {
		$_REQUEST['comment_status'] = ($_REQUEST['comment_status']) ? 'open' : 'closed';
	}
	else {
		$_REQUEST['comment_status'] = $ads_options['ads_comments'];
	}

}
/*
	устанавливает ads_basecat - базовую категорию объвления
*/
function set_basecat(){
    global $ads_options;
   	if(!(int)$_REQUEST['ads_basecat']){
        if($ads_options['ads_base_category'])
			$_REQUEST['ads_basecat'] = $ads_options['ads_base_category'];
		else
		    $_REQUEST['ads_basecat'] = get_option('default_category');
	}
}

function set_category(){
    if(sizeof($_REQUEST['post_category']))
        $_REQUEST['post_category'] = array_merge($_REQUEST['post_category'],array($_REQUEST['ads_basecat']));
    else
        $_REQUEST['post_category'] = array($_REQUEST['ads_basecat']);
}
/*
  сохранение данных
*/
function save_form(){
    $this->set_user_post();
    $this->set_comments();
    $this->set_basecat();
    $this->set_category();

    //  отключаем ревизии  pre_post_update wp_save_post_revision
    remove_action('pre_post_update', 'wp_save_post_revision');
    //  подключаем фитр для добавления полей adp_
    add_filter('wp_insert_post_data','ads_table_fields',10,2);
    if((int)$_REQUEST['ID'] ){
        // проверяем может ли пользователь редактировать запись
        if($this->can_edit() AND get_post($_REQUEST['ID']) ){
            wp_delete_object_term_relationships($_REQUEST['ID'], array('post_tag'));
            $ads_ID = wp_update_post($_REQUEST);
            if( $ads_ID != $_REQUEST['ID'] ) {
                $this->wp_error->add('save_form', __('Error in save_form() -> wp_update_post().'));
                $_REQUEST['post_status'] = get_post_status($_REQUEST['ID']); // возвращаем статус в исходное положение
                return false;
            } else{
                $_SESSION['ads_posts_edit'][$ads_ID][] =  time();
            }
        } else {
            $this->wp_error->add('save_form', __('Error in save_form() -> wp_update_post() do not update post.'));
            $_REQUEST['post_status'] = get_post_status($_REQUEST['ID']); // возвращаем статус в исходное положение
            return false;
        };
    }else{  // новый пост
        if(!$this->can_new_post())  return false;

        $ads_ID = wp_insert_post( $_REQUEST, 1 );
        if(is_wp_error($ads_ID) ) {
            $this->wp_error = $ads_ID;
            $_REQUEST['post_status'] = '';
            return false;
        }else {
            $_REQUEST['ID'] = $ads_ID;
            $_REQUEST['ads_password'] = genPassword();
            $_REQUEST['ads_IP'] = getip();
            $this->NEW_POST = true;
            $_SESSION['ads_posts_edit'][$ads_ID][] =  time();
		    $_SESSION['last_post'] = time();
        }
    }
    //http://wp29/?p=164&preview=true
    $this->save_meta();
    $this->print_msg('saved');
    return $ads_ID;
}


function  download_file( &$attachments ){
    if( function_exists('stream_context_create')){
        $opts = array(
          'http'=>array(
            'method'=>"GET",
            'header'=>"Accept-language: {$_SERVER['HTTP_ACCEPT_LANGUAGE']}\r\n" .
                      "Cookie: {$_SERVER['HTTP_COOKIE']}\r\n" .
                      "User-Agent: {$_SERVER['HTTP_USER_AGENT']}\r\n"
          )
        );
       $context = stream_context_create($opts);
    }
    foreach ($_REQUEST['ads_files'] as $key=>$url) {
        if(!$url OR isset($attachments[$key]) OR $_FILES[$key]['size'] ) continue;
        $file = file_get_contents($url, false, $context);
        $tmp_dir = get_cfg_var("upload_tmp_dir");
        $tmpfname = tempnam($tmp_dir, "ads_");
        $handle = fopen($tmpfname, "w");
        fwrite($handle, $file);
        fclose($handle);
        if( $type = mime_content_type ( $tmpfname ) ) {
			list($type,$binary) =  explode(';', $type);

		}
        else {
			$type = wp_check_filetype($tmpfname);
			$type = $type['type'];
		}
		$suffix = str_replace('/', '.', strrchr($type,'/') );
		if( ! preg_match("|\.([a-z0-9]{2,4})$|i", basename($url) ) ){
			$url .= $suffix;
			rename ($tmpfname, $tmpfname.$suffix);
			$tmpfname = $tmpfname.$suffix;
		}

        $_FILES[$key] = array(
            'name'=>  basename($url),
            'type' => $type,
            'tmp_name' => $tmpfname,
            'size' => filesize($tmpfname),
            'error' => 0
        );
    }
}
/*
	загружаем загрузки
 Array
        (
            [name] => 12743803594.jpg
            [type] => image/jpeg
            [tmp_name] => S:\tmp\php25C.tmp
            [error] => 0
            [size] => 143934
        )
*/
function upload(){
    global $ads_options;
    include_once(ABSPATH . '/wp-admin/includes/image.php');
    include_once(ABSPATH . '/wp-admin/includes/media.php');
    include_once(ABSPATH . '/wp-admin/includes/file.php');

    $attachments = $this->get_attachments();
    if(sizeof($_REQUEST['ads_files'])) $this->download_file( &$attachments );
    $_FILES = apply_filters('ads_check_files', $_FILES, &$attachments, &$this);
    if($_FILES['error']){
        $this->wp_error->errors['upload_error'] =  $_FILES['error'];
        return false;
    }

    if( !sizeof($_FILES) OR !$ads_options['ads_count_upload'] ) return;


    $ads_max_size = floatval($ads_options['ads_max_size'])  * 1024 * 1024;
    $ads_max_img_x  = $ads_options['ads_max_img_x'];
    $ads_max_img_y  = $ads_options['ads_max_img_y'];
    for ($key = 0; $key < $ads_options['ads_count_upload']; $key++) {
        if($_FILES[$key]['size'] > 0 AND !isset($attachments[$key]) ){
            if($ads_max_size AND ($ads_max_size < $_FILES[$key]['size']) ){
                $this->wp_error->errors['upload_error'][$key]  =  __("Upload error: exceeded the maximum file size!",'ads-wordpress');
            }
            elseif(!ads_check_type_file($_FILES[$key]['type']))
                $this->wp_error->errors['upload_error'][$key]  =  __("Upload error: prohibited file type!",'ads-wordpress');

            else
                $_files[$key] = $_FILES[$key];

            //  обрезка больших фото
            if((int)$ads_max_img_x and (int)$ads_max_img_y){
                list($orig_w, $orig_h, $orig_type) = getimagesize( $_files[$key]['tmp_name'] );
                if( ($ads_max_img_x < $orig_w) or ($ads_max_img_y<$orig_h) ){
                    $new_file = image_resize( $_files[$key]['tmp_name'], $ads_max_img_x, $ads_max_img_y);
    				if($new_file){
    					unlink($_files[$key]['tmp_name']);
    					rename($new_file,$_files[$key]['tmp_name']);
    				}
                }
            }
        }
    }

    if(!sizeof($_files)) return;

    // если запись не созданна создаем черновик  с заголовком записи ads_draft
    if(!(int)$_REQUEST['ID']){
        if(!$this->can_new_post())  return false;

        $ads_ID = wp_insert_post( array('post_title'=>'ads_draft','post_status'=>'draft'), 1 );
        if(is_wp_error($ads_ID) ) {
            $this->wp_error = $ads_ID;
            $_REQUEST['post_status'] = '';
            return false;
        }
        $_REQUEST['ID'] = $ads_ID;
        $_REQUEST['post_status'] =  'draft';
        $_REQUEST['ads_password'] = genPassword();
        $this->NEW_POST = true;
        $_SESSION['ads_posts_edit'][$ads_ID][] =  time();
	    $_SESSION['last_post'] = time();
	    $this->save_meta();
    }
    foreach ($_files as $key=>$file) {
        $file_id = media_handle_sideload($_files[$key], $_REQUEST['ID'], '' ,array('menu_order'=>$key) );
        if(is_wp_error($file_id) ) {
            $error =  implode( "\n", $file_id->get_error_messages());
            $this->wp_error->errors['upload_error'][$key] = $error;
        }

    }
}

function get_attachments(){
    global $wpdb;
    if(!$_REQUEST['ID']) return false;
    $query = "SELECT $wpdb->posts.* FROM $wpdb->posts WHERE  ($wpdb->posts.post_parent = {$_REQUEST['ID']})  AND $wpdb->posts.post_type = 'attachment'";
    $tmp_wpdb = new wpdb(DB_USER, DB_PASSWORD, DB_NAME, DB_HOST);
    $arr = $tmp_wpdb->get_results($query,ARRAY_A);
	if(!$arr) return false;
    foreach ($arr as $key=>$atach) {
        $metadata =  wp_get_attachment_metadata($atach['ID']);
        $order =  $atach['menu_order'];
        $files[$order] = $atach;
        if(wp_attachment_is_image($atach['ID'])){
            $files[$order]['thumbnail'] = wp_get_attachment_thumb_url( $atach['ID']);
        }else{
            $files[$order]['thumbnail'] = wp_mime_type_icon( $atach['ID'] );
        }
    }
    return  $files;
}

/*
	поворот картинки
*/
function file_rotate(){
	$atach_ID = @key($_REQUEST['ADS_ACTION'][$this->action]);
	if(!(int)$atach_ID) {
		$this->wp_error->add('file_delete', __('Error, no atacment ID!','ads-wordpress'));
		return false;
	}
	$attachment = get_post($atach_ID);
	if($attachment->post_parent == $_REQUEST['ID']){
        if( function_exists('imagerotate')) {
            if($this->action == 'ROTATE_LEFT') $ugol = 90;
            else $ugol = -90;
            $res = wp_get_attachment_metadata($atach_ID);
            $uploads_dir = wp_upload_dir('baseurl');
            $file = $uploads_dir['basedir'].'/'.$res['file'];
            $file_dir = dirname($file);
            foreach ($res['sizes'] as $key=>$value) {
                unlink($file_dir.'/'.$value['file']);
            }
    		include_once(ABSPATH . '/wp-admin/includes/image.php');
    		$source = @imagecreatefromjpeg($file);
    		$rotate = imagerotate($source, $ugol, 0);
    		imagejpeg ($rotate , $file);
    		return wp_update_attachment_metadata( $atach_ID, wp_generate_attachment_metadata( $atach_ID, $file ) );
    	}
    	else {
    		$this->wp_error->add(__("The function imagerotate() is not supported.",'ads-wordpress'));
    		return false;
    	}
	} else {
		$this->wp_error->add('file_delete', __('Error, post_parent not file does not match the current record!','ads-wordpress'));
		return false;
	}
}
/*
	удаляет файл (загрузку)
*/
function file_delete(){
	$atach_ID = @key($_REQUEST['ADS_ACTION'][$this->action]);
	if(!(int)$atach_ID) {
		$this->wp_error->add('file_delete', __('Error, no atacment ID!','ads-wordpress'));
		return false;
	}
	$attachment = get_post($atach_ID);

	if($attachment->post_parent == $_REQUEST['ID']){
		$res = wp_delete_attachment($atach_ID);
		if(is_wp_error($ads_ID) ) {
			$this->wp_error = $res;
			return false;
		}
		return $res;
	} else {
		$this->wp_error->add('file_delete', __('Error, post_parent not file does not match the current record!','ads-wordpress'));
		return false;
	}
}


/*
	отсылает почту
*/
function send_mail(){
    global $ads_config,$ads_options;

    if(!$_REQUEST['ads_email']) return;
    if($this->NEW_POST){
        if(!$ads_options['ads_email_new_post']) return;
        $template = $ads_config['email_new_post'];
    } else{
        if(!$ads_options['ads_email_edit_post']) return;
        $arr_saves = $_SESSION['ads_posts_edit'][$_REQUEST['ID']];
         $save_last = array_pop($arr_saves);
        $cave_penult  = array_pop($arr_saves);
        // повторное подтверждение отсылается если если разница
        // между редакциями по времени более 15 мин
        if( ($save_last - $cave_penult) < 90) return;
        $template = $ads_config['email_edit_post'];

    }
    extract($_REQUEST);
    $ads_password = $_REQUEST['ID'].'.'.$ads_password;
    $title = __('Notice from ','ads-wordpress'). get_bloginfo( 'url' );
    $urlEdit = get_bloginfo('wpurl').'/?page_id='.$ads_options['ads_edit_page'].'&ADS_ACTION[LOGIN]=1&ads_password='.$ads_password;
    $urlDelete = get_bloginfo('wpurl').'/?page_id='.$ads_options['ads_edit_page'].'&ADS_ACTION[LOGIN_DELETE]=1&ads_password='.$ads_password;
    $postUrl = get_permalink($postID);

  	ob_start();
	include_once($ads_config['dir_template'].$template);
	$message = ob_get_contents();
	ob_end_clean();
    $message .= "\n " . __("Plugin Ads WordPress from http://ili.com.ua/wordpress/ads-wordpress ",'ads-wordpress');
    wp_mail($ads_email,$title, $message);
}


/*
	заменяет автора сообщени на то что указано в опциях
*/
function set_user_post(){
    global $user_ID, $ads_options;
	if(!$user_ID and $ads_options['ads_user_id']) {
	     $_REQUEST['post_author'] = $ads_options['ads_user_id'];
	}
}
/*
	пишет сообщение

*/
function print_msg($code){
    $s = __('publish').__('draft').__('pending');
    switch ($code) {
        case 'saved':
            $preview_link = add_query_arg('preview', 'true', get_permalink($_REQUEST['ID']) );
?>
<div align='right'>
<?_e('Your entry №','ads-wordpress')?> <b><?=$_REQUEST['ID']?></b> <?_e('is edited successfully.','ads-wordpress')?><br />
<nobr><?_e('Password:','ads-wordpress')?>  <u><b><?=$_REQUEST['ID'].'.'.$_REQUEST['ads_password']?></b></u>;</nobr>
<nobr><?_e('Status:','ads-wordpress')?> <b><?_e($_REQUEST['post_status'],'ads-wordpress')?></b>;</nobr>
<?if($_REQUEST['post_status']=='publish'):?>
<nobr><a href='<?=$preview_link?>' target='_blank'><?_e('Review','ads-wordpress')?></a></nobr>
<?else:?>
<nobr><a href='<?=$preview_link?>' target='_blank'><?_e('Preview','ads-wordpress')?></a></nobr>
<?endif;?>
</div>
<?
        break;
        case 'no_new_post':
?>
<font color="#FF0000" size="2"><?=implode( "\n", $this->wp_error->get_error_messages() ) ?></font><br />
<?
        break;
        default:
    	   echo __('empty message?','ads-wordpress');
    	break;
    }
}
/*
	проверяет может ли пользователь создатть новую запись
	проверяем интервал сообщений
*/
function can_new_post(){
	global $ads_options,$user_ID;
	 if(current_user_can( 'edit_others_posts', $user_ID )) return true;
	$timeInterval = (real)$ads_options['ads_interval']*3600;
	if(!$timeInterval) $timeInterval = 300;
	if( ( time() - $_SESSION['last_post'] ) < $timeInterval ) {
		$ostTime = $timeInterval - ( time() - $_SESSION['last_post']);
		$min = floor($ostTime / 60);
		$sec = $ostTime % 60;
		$hors = floor($min/60);
		$min = $min % 60;
		$this->wp_error->add('can_new_post', sprintf (__("Sorry, you can write next entry after %d hours %d min %d sec. <br /><a target='_top' href = './'>Home page</a>",'ads-wordpress'),$hors,$min,$sec) );
		return false;
	}
	return true;
}
/*
	функция проверяет возможность удаления поста
*/
function  can_delete(){
    global $user_ID;
    if($user_ID){
        if(user_can_delete_post($user_ID, $_REQUEST['ID']))
            return true;
        else{
            $this->wp_error->add('can_delete', __('Error, You do not delete this entry!','ads-wordpress'));
            return false;
        }
    }else{
        $ads_password = get_post_meta($_REQUEST['ID'], 'ads_password', 1);
        if( $ads_password AND ($ads_password == $_REQUEST['ads_password']) )
            return true;
        else {
            $this->wp_error->add('can_delete', __('Error, incorrect password or ID, do not delete this entry!','ads-wordpress'));
            return false;
        }
    }
}

/*
	судя по названию удаляет запись со всеми причендалами
*/
function delete(){
    if(!(int)$_REQUEST['ID']) {
        $this->wp_error->add('delete',  __('No delete - empty post ID!', 'ads-wordpress') );
        return false;
    }
    $defaults = array(
		'numberposts' => -1, 'post_type' => 'any',
		'post_status' => 'any', 'post_parent' => $_REQUEST['ID'],
	);
	$arr_delete = get_posts($defaults);
    $post =  get_post($_REQUEST['ID']);
    $arr_delete[] = $post;

    krsort ($arr_delete);
    reset ($arr_delete);
	foreach ($arr_delete as $key=>$post) {
		$res = wp_delete_post($post->ID,1);
        $title = ($post->post_title) ? $post->post_title : $post->post_name;
        $msg = ($res)?'Delete':'Error';
		echo "<b>ID:</b> $post->ID;  <b>type:</b> $post->post_type;  <b>name:</b>  $title - $msg. <br />";
	}
}


/*
	проверяет может ли пользователь редактировать запись
*/
function can_edit(){
    global $user_ID;
    if($user_ID){
        if(user_can_edit_post($user_ID, $_REQUEST['ID']))
            return true;
        else{
            $this->wp_error->add('can_edit', __('Error, You do not edit this entry!','ads-wordpress'));
            return false;
        }
    }else{
        $ads_password = get_post_meta($_REQUEST['ID'], 'ads_password', 1);
        if( $ads_password AND ($ads_password == $_REQUEST['ads_password']) )
            return true;
        else {
            $this->wp_error->add('can_edit', __('Error, incorrect password or ID, do not edit this entry!','ads-wordpress'));
            return false;
        }

    }
}
/*
	сохраняет мета поля  с ads_
	в таблица
*/
function save_meta(){
    if(!$_REQUEST['ID']) return false;
	foreach ($_REQUEST as $key=>$value) {
	   if( strpos($key,'ads_')===0 ) {
    		if(get_post_meta($_REQUEST['ID'], $key)){
    		    if(empty($value)) delete_post_meta($_REQUEST['ID'], $key);
    		    else  update_post_meta($_REQUEST['ID'], $key, $value);
    		}else{
                 if(!empty($value)) add_post_meta($_REQUEST['ID'], $key, $value);
    		};
	   }
	}
	return true;
}
/*

Returns form template in accordance with the category
line is set in a config.php form_templates
If the category template is not defined
checks whether the category of descendants if there are prints sublayer
and nourish false
if no descendants return to the default template
*/
function category_template($base_category = 0){
    global $ads_config, $ads_options;
    $opt_basecat = $ads_options['ads_base_category'];
    $ads_exclude = $ads_options['ads_exclude'];
    extract($ads_config, EXTR_SKIP);
    $form_templates = $ads_config['form_templates'];
    // получаем масив родителей категории
    if($base_category AND ($base_category!=$opt_basecat) )
        $arr_parent = ads_get_parents_id($base_category);
    // проверяем чтобы категория не содержалась в списке  $ads_exclude  и не была одним из потомков
    // категории этого списка
    if($ads_exclude AND $arr_parent){
        $arr_exclode = explode(',',trim($ads_exclude));
        foreach ($arr_exclode as $key=>$value) {
        	$arr_exclode[$key] = trim($value);
        }
        $res = @array_intersect($arr_parent, $arr_exclode);
        if( sizeof($res) )  {
            $this->wp_error->add( 'ads_main', __("Error: ads_basecat category within the list of exceptions!",'ads-wordpress') );
            return false;
        }
    }

    if((int)$opt_basecat AND $arr_parent AND !@in_array($opt_basecat,$arr_parent) ){
        $this->wp_error->add( 'ads_main', __("Error: ads_basecat category is not a descendant of the basic categories!",'ads-wordpress') );
        return false;
    }

    if($form_templates['all']) return $form_templates['all'];
    if($base_category)
        $category = get_category($base_category);
    else
        $category = get_category($opt_basecat);

    if(isset($form_templates[(int)$opt_basecat])) return $form_templates[$opt_basecat];
    if(isset($form_templates[(int)$base_category])) return $form_templates[$base_category];
    if(isset($form_templates[$category->name])) return $form_templates[$category->name];
    if(isset($form_templates[$category->slug])) return $form_templates[$category->slug];

    if($base_category)
        $categories = get_categories(array('child_of' =>$base_category, 'hide_empty'=>0,'exclude'=>$ads_exclude));
    elseif($opt_basecat)
        $categories = get_categories(array('child_of' =>$opt_basecat,'hide_empty'=>0,'exclude'=>$ads_exclude));
    else
        $categories = get_categories(array('hide_empty'=>0,'exclude'=>$ads_exclude ));
    if(sizeof($categories)<2){
        unset($categories);
		return $form_templates['default'];
    }
 	return false;
}

/*
	проверка вводимых данных
    общий принцип  - если проверка пойдена возращаем true иначе false
    ошибки записываем в $this->error
*/
function check_form(){

    $_REQUEST = apply_filters('ads_check_fields', $_REQUEST, & $this);

    if($_REQUEST['error']){
        if( is_array($_REQUEST['error']) ) {
            foreach ($_REQUEST['error'] as $key=>$error) {
                $this->wp_error->errors[$key] = (is_array($error)) ? $error : array($error);
            }

        }
        else $this->wp_error->errors['main'][] = $_REQUEST['error'];
    }
    if(!($_REQUEST['post_content'] OR $_REQUEST['post_title'])){
		$this->wp_error->add( 'ads_main', __("Error: Enter the text of announcement or title!",'ads-wordpress') );
    }
    if(!$this->name_template) $this->wp_error->add( 'ads_main', __("Error: mismatch base category!",'ads-wordpress') );

 	$this->check_ifetime();
	$this->check_set_tags();

    if(sizeof($this->wp_error->errors)) return false;
    return true;
}


/*
	обрабатывает метки для запси
	массив ar_tags - не обрабатываеца
	а строка tags_input  - проверяеца  максимальное кол-во тегов 5
	без запрещенных символов и не длинее 26 символоа
*/
function check_set_tags(){
	global $ads_options;
	// метки                    1
  	if($_REQUEST['ar_tags']){
       $_REQUEST['tags_input'] = $_REQUEST['ar_tags'];
	}
	elseif($_REQUEST['tags_input'] AND $ads_options['ads_user_tags']){
        if(preg_match( '~,~',$_REQUEST['tags_input']))
            $arrTags = explode( ',', trim($_REQUEST['tags_input'], " \n\t\r\0\x0B,")                  );
        else
            $arrTags[] = $_REQUEST['tags_input'];
        if(sizeof($arrTags) > 5){
           $this->wp_error->add( 'tags_input', __("Error:",'ads-wordpress')." ($tag) - ".__("no more than 5 tags!",'ads-wordpress'));
        }
        $xerna = '|['.preg_quote('`~!@#$%^&*()=+№{}<>?|:;"\'[]').']+|u';
        foreach ($arrTags as $tag) {
            if(preg_match($xerna,$tag)){
        		$this->wp_error->add( 'tags_input', __("Error: It the tag",'ads-wordpress')." ($tag) ".__("you can use only letters, digits and _",'ads-wordpress') );
            };
            if( preg_match('~.{26,}~u',$tag) ){
        		$this->wp_error->add( 'tags_input', __("Error:",'ads-wordpress')." ($tag) — ".__("tags no more than 25 symbols from comma to comma!",'ads-wordpress') );
            };

        }
	}else{
		unset($_REQUEST['tags_input']);
	}

}
function check_ifetime(){
    if(isset($_REQUEST['ads_lifetime'])){
       if(empty($_REQUEST['ads_lifetime'])) unset($_REQUEST['ads_lifetime']);
       elseif(is_numeric($_REQUEST['ads_lifetime']) AND ($_REQUEST['ads_lifetime']>0) ){

       }else{
            $this->wp_error->add( 'ads_lifetime', __("Error: Period of the entry — incorrect format of the field!",'ads-wordpress') );
       }
    }
}
function error_msg($code='',$key = -1){
    if( $this->wp_error->errors[$code] )
        if($this->wp_error->errors[$code][$key])
            echo "<font class=\"ads_error\" color=\"#FF0000\">".$this->wp_error->errors[$code][$key]."</font>";
        else
            echo "<font class=\"ads_error\" color=\"#FF0000\">".implode("\n", $this->wp_error->errors[$code] )."</font>";
}
function get_url_captcha(){
    global $ads_config,$ads_options;
    if($_REQUEST['ID'] OR ($_REQUEST['ads_captcha'] AND ($_REQUEST['ads_captcha'] === $_SESSION['ads_captcha']) ) )
        return false;
    if($ads_options['ads_capthca'])
        return $ads_config['urlDir'].'ads_captcha.php?'.session_name().'='.session_id();
    return false;
}

/*
	проверяет ввод каптчи или надоли ее вообще вводить
если все хорошо возвернет труе
*/
function  check_captcha(){
    global  $ads_options;

    if($_REQUEST['ID'] OR !$ads_options['ads_capthca']) return true;
    if($_REQUEST['ads_captcha'] AND ($_REQUEST['ads_captcha'] === $_SESSION['ads_captcha'])) return true;
    $this->wp_error->add( 'ads_captcha', __("Incorrect code from the picture!",'ads-wordpress') );
}
/*
	если tags_input  - массив значит мы используем
ar_tags самостоятельный ввод тегов через массив и
tags_input  просто удаляем
*/
function get_tags(){
	if(is_array($_REQUEST['tags_input']))
		unset($_REQUEST['tags_input']);
}
/*
	печатет форму
*/
function print_form(){
    global $ads_config, $ads_options;
    $url_captcha = 	$this->get_url_captcha();
    $this->get_tags();
    extract($ads_config, EXTR_SKIP);
	extract($ads_options, EXTR_SKIP);
	//
	if(	$_REQUEST['comment_status'] == 'closed') unset($_REQUEST['comment_status']);
	@extract($_REQUEST, EXTR_SKIP);
    if(is_wp_error($this->wp_error) ){
        $msg = implode( "\n", $this->wp_error->get_error_messages() ).'<br style="clear:both" />';
    }

    if($this->name_template) { //печатем форму
        // подготовим  ошибки для вывода
		ob_start();
    	include $ads_config['dir_template'].$this->name_template;
    	$html_form = ob_get_contents();
    	ob_end_clean();
		$ob = new HTML_FormPersister();
		$_POST = $_REQUEST;
		$html_form = $ob->process($html_form);
		$html_form = $this->add_hidden_fields($html_form);
		$html_form;
    }
    elseif(!$this->AdsFormEdit) { // если мы на стадии выбора категории то сбрасываем текущую сессию
        ob_start();
        include $ads_config['dir_template'].'/choice_category_template.php';
        $html_form = ob_get_contents();
    	ob_end_clean();
    }else{
        $html_form =  "<font color=\"#FF0000\" size=\"2\">$msg</font><br />";
    }

    $this->content = preg_replace('~<!--AdsForm[^>]*-->~i' , str_replace('\\0', '', $html_form), $this->content);
}

/*
	загружает данные в $_REQUEST  массив
*/
function load_data()
{
    $load_post = get_post($_REQUEST['ID'],ARRAY_A);
    // загружаем мета поля
    $arrCustom = get_post_custom($_REQUEST['ID']);
    foreach ($arrCustom as $key=>$value) {
        $args[$key] = array_shift($value);
  	}
  	// загружаем теги
    if($arr = wp_get_post_tags($_REQUEST['ID'])){
        foreach ($arr as $key=>$value) {
           $arr2[] = $value->name;
        }
        $args['tags_input'] = implode(', ',$arr2);
        $args['ar_tags'] = $arr2;
    }

    // загружаем категориии
    $args['post_category'] = wp_get_post_categories($_REQUEST['ID']);

    $_REQUEST  = array_merge($load_post,$args);
	// получаем текущий шаблон формы
    $this->name_template = $this->category_template($_REQUEST['ads_basecat']);
    return true;
}
/*
проверяет коректность пользовательского пароля
пароль состтоит из ID.ads_password  через точку
устанавливает ID и  ads_password
вариант 2 логинется если у паользователя есть права доступа к этой записи
тоесть мы заходим по ссылке редактировать  $this->action == 'EDIT'
*/
function ads_login(){
    if(preg_match('~\d{1,6}\.[\d\w]+~i',$_REQUEST['ads_password'])){
        list($ads_ID,$ads_password) = explode('.',trim($_REQUEST['ads_password']));
        $get_password = get_post_meta($ads_ID, 'ads_password', 1);
        if($ads_password == $get_password){
            $_REQUEST['ID'] = $ads_ID;
            $_REQUEST['ads_password'] = $ads_password;
            return true;
        }
    }
    elseif($this->action == 'EDIT'){
        global $user_ID;
        if(!(int)$_REQUEST['ID']) $_REQUEST['ID'] = $_REQUEST['ADS_ACTION']['EDIT'];
        if(user_can_edit_post($user_ID, $_REQUEST['ID']))
            return true;
        else{
            $this->wp_error->add('save_form', __('Error, You do not edit this entry!','ads-wordpress'));
            return false;
        }
    }
    $this->wp_error->add('login', __("Incorrect  password, please, repeat data input.",'ads-wordpress'));
    return false;
}
/*
	печатает форму входа для редактирования записи
*/
function login_form(){
    global $ads_config;
    if(is_wp_error($this->wp_error) ){
        $wp_error = &$this->wp_error;
        $msg = implode( "\n", $wp_error->get_error_messages() );
    }
    include_once $ads_config['dir_template'].$ads_config['form_login'];
}


/*
	дабавляет в обработаную форму скрытые поля
	если есть ID записи то добаляется он
*/
function add_hidden_fields($html_form){
    global $user_ID;
    if($_REQUEST['ID']){
        $hidden = '<input type="hidden" name="ID" value="'.$_REQUEST['ID']."\"/>\n";
        $hidden .= '<input type="hidden" name="ads_password" value="'.$_REQUEST['ads_password']."\"/>\n";
        if($this->AdsFormEdit)
            $hidden .= '<input type="hidden" name="ads_basecat" value="'.$_REQUEST['ads_basecat']."\"/>\n";
        $hidden .= '</form>';
        $html_form = preg_replace('~</form>~i', $hidden , $html_form);
    }elseif(!empty($_SESSION['ads_captcha']) AND ($_REQUEST['ads_captcha'] === $_SESSION['ads_captcha']) ){
        $hidden = '<input type="hidden" name="ads_captcha" value="'.$_REQUEST['ads_captcha']."\"/>\n";
        $hidden .= '</form>';
        $html_form = preg_replace('~</form>~i', $hidden , $html_form);
    }
    return $html_form;
}

/*
	отфильтровывает переменные которые не указаны в фильтре
	работает напрямую с $_REQUEST
*/
function filter_fields_form(){
	foreach ($_REQUEST as $key=>$value) {
			if(!in_array($key,$this->ads_fields_form)){
					unset($_REQUEST[$key]);
			}
	}
}

/*
	 комбинироует список-фильтр разрешонных полей из текущего сессии и ads_config.php
	 и добавляет обязательные поля
*/
function comb_fields_form(){
    global $ads_config;
    $_SESSION['ads_fields_form'] = @array_unique($_SESSION['ads_fields_form']);
    if($_SESSION['ads_fields_form'])
        $this->ads_fields_form  = array_merge($ads_config['ads_fields_form'], $_SESSION['ads_fields_form']);
    else
        $this->ads_fields_form  = $ads_config['ads_fields_form'];
	//  список обязательных полей
    $default_fields  = array('ads_basecat', 'ads_password','ID','ADS_ACTION','ads_captcha','ads_files');
    $this->ads_fields_form = array_merge($this->ads_fields_form, $default_fields );
    $this->ads_fields_form = array_unique ($this->ads_fields_form);
}
/*
	если установленна опция $ads_user_status   только для зарегистрированных пользователей
проверяет статус пользователя
если все в порядке то вернет false !
*/
function  check_user_status(){
    global $ads_options;
    if($ads_options['ads_user_status'] > 0){
       $wp_user = wp_get_current_user();
       if(!$wp_user->id ){
         return __("You are not authorized to access this page, you must register.",'ads-wordpress');
       }
    }
}
} // END class ads_form_handler

$ads_form_handler  = new  ads_form_handler;
add_filter('the_content', array(&$ads_form_handler, 'ads_main'),10);


function ads_ob_start(){
	ob_start();
}
add_action('init','ads_ob_start');

/*
всякий раз когда происходит редактирование или добавление записи
сбрасывается кеш группы 'ads'
*/
function ads_clear_cache(){
    global $wp_object_cache;
    if( $wp_object_cache->cache['ads'] )
        unset( $wp_object_cache->cache['ads'] );
    else
        $wp_object_cache->flush();
}

add_action('save_post','ads_clear_cache');

function ads_table_fields($data,$postarr){
    foreach ($postarr as $key=>$value) {
      if( strpos($key,'adp_')===0 ) {
        if(is_array($value))
            $data[$key] = implode(',',$value);
        else
            $data[$key] = $value;
      }
    }
  return $data;
}

/*
	для предварительного просмотра изменяет статус на publish
    если  если в сесии ads есть эта запись
*/
function ads_prevew($posts){
    if($_GET['preview'] != 'true') return $posts;
    session_name ('ads');
    session_start();
    if(isset($_SESSION['ads_posts_edit'][$posts[0]->ID]))
        $posts[0]->post_status = 'publish';
    return $posts;
}
add_filter('posts_results', 'ads_prevew');

/*
	перенаправляет ссылки редактировать запись на редактор плагина
*/
function ads_get_edit_post_link($url, $postID='', $cotext=''){
    global $ads_options;
    if(!$url) return;
    if(!current_user_can( 'edit_posts')) return;
    if(!is_admin())
        if( $ads_basecat = get_post_meta($postID, 'ads_basecat', 1) )
               return get_bloginfo('wpurl').'/?page_id='.$ads_options['ads_edit_page'].'&amp;ADS_ACTION[EDIT]='.$postID;
    return $url;
}
if($ads_options['ads_edit_page'])
    add_filter('get_edit_post_link','ads_get_edit_post_link',1,3);



/*
   Adds a page in the admin panel settings-Ads
*/
function admin_menu_add_pages(){
		// Add a new submenu under Options:
    add_options_page('Ads', 'Ads WordPress', 8, __FILE__, 'ads_admin_page');
}

/*
	Handles options in admin panel
*/
function ads_admin_page() {
		global $ads_config, $ads_options, $wpdb;
		$opt_name = $ads_config['opt_name'];
    // See if the user has posted us some information
    // If they did, this hidden field will be set to 'Y'
    if( $_POST['Submit'] ) {
				$ads_options = $_POST;

	    if($_POST['ads_user_name']){
	    	$ads_user_name = $_POST['ads_user_name'];
				$ads_user_id = $wpdb->get_var( $wpdb->prepare( "SELECT ID FROM $wpdb->users WHERE user_login = '$ads_user_name'" ));
				$ads_options['ads_user_id'] = $ads_user_id;
      }

				// Save the posted value in the database
        update_option( $opt_name, $ads_options );

        // Put an options updated message on the screen

?>
<div class="updated"><p><strong><?php _e('Options saved.','ads-wordpress'); ?></strong></p></div>
<?php

    }
    else {
    		$_POST = $ads_options;
    }

    // Now display the options editing screen

    echo '<div class="wrap">';

    // header

    echo "<h2>Ads WordPress</h2>";

    // options form
		ob_start();
        if(!sizeof($ads_options)){
            $_POST['ads_count_upload'] = 4;
            $_POST['ads_template_apply'] = 4;
        }
    ?>

<form name="form1" method="post" action="<?=str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
<table class="form-table">
<tbody>
 <tr>
 <td width="50%"><?_e('Replace the anonymous user to user:','ads-wordpress')?></td>
 <td><input type="text" name="ads_user_name" size="20"/></td>
 </tr>

 <tr>
 <td width="50%"><?_e('What to do with a message from an anonymous user, set stutus message:','ads-wordpress')?></td>
 <td>
 	<select name="ads_post_status">
  			<option  value="draft">draft</option>
  			<option  value="pending">pending</option>
  			<option  value="publish">publish</option>
     </select>
	</td>
 </tr>

 <tr>
 <td width="50%">Comments:</td>
 <td>
 	<select name="ads_comments">
			<option  value="open">open</option>
  			<option  value="closed">closed</option>
  			<option  value="optional">optional</option>
     </select>
	</td>
 </tr>
 <tr>
 <td>
<?_e("Notify the author by e-mail when a new comment on his announcement, (council) that the comments should be published immediately",'ads-wordpress')?>
 </td>
 <td><input type="checkbox" name="ads_comments_ping" /></td>
 </tr>

 <tr>
 <td><?_e('Auto gap, auto','ads-wordpress')?> &lt;!--more--&gt;</td>
 <td><input type="checkbox" name="ads_auto_more"/><input type="text" size="4" name="ads_count_str_more"/><br /><?_e('number of characters in the announcement','ads-wordpress')?></td>
 </tr>
 <tr>
 <tr>
 <td><?_e('The time interval between messages in hours','ads-wordpress')?></td>
 <td><input type="text" size="4" name="ads_interval"/></td>
 </tr>
 <tr>
 <td><?_e('Antibot image (capthca)','ads-wordpress')?></td>
 <td><input type="checkbox" name="ads_capthca"/></td>
 </tr>
 <tr><td><?_e('Number of uploads','ads-wordpress')?></td>
 <td><input type="text" name="ads_count_upload" size="5"/></td>
 </tr>
 <tr><td><?_e('The maximum size in megabytes','ads-wordpress')?></td>
 <td><input type="text" name="ads_max_size" size="5"/></td>
 </tr>
 <tr><td><?_e('Allowed file types (multiple choice with pressed Ctr)','ads-wordpress')?></td>
 <td>
 	<select style = "height:7em;" name="ads_file_types[]" multiple>
 		<option value="image">image</option>
 		<option value="video">video</option>
 		<option value="audio">audio</option>
 		<option value="text">text</option>
 		<option value="application">application</option>
     </select>
 </td>
 </tr>
 <tr>
 <td><?_e('Compress large photos <br /> an aspect','ads-wordpress')?></td>
 <td><input type="text" name="ads_max_img_x" size="5">X<input type="text" name="ads_max_img_y" size="5"/></td>
 </tr>
 <tr>
 <td><?_e('Delete column id, separated by commas','ads-wordpress')?></td>
 <td><input type="text" name="ads_exclude" size="20"/></td>
 </tr>
 <tr>
 <td><?_e('Parent topic of categories will be available in the announcement to select column','ads-wordpress')?></td>
 <td><input type="text" name="ads_base_category" size="5"/></td>
 </tr>
 <tr>
 <td><?_e('Selection list of categories','ads-wordpress')?></td>
 <td><input type="checkbox" name="ads_desc_category" /><?_e('description','ads-wordpress')?>
 <input type="checkbox" name="ads_expand_category" /><?_e('expand','ads-wordpress')?>
 <input name="ads_depth_category" size="2"/> <?_e('depth of the display (counting from zero)','ads-wordpress')?>
 </td>
 </tr>
 <tr>
 <td><?_e('Ads Location category ID','ads-wordpress')?></td>
 <td><input type="text" name="ads_location_root" size="3"/></td>
 </tr>
 <tr>
 <td><?_e('Apply templates posts','ads-wordpress')?></td>
 <td><input type="checkbox" name="ads_template_apply" size="5"/></td>
 </tr>
 <tr>
 <td><?_e('Add announcement number to the title','ads-wordpress')?></td>
 <td><input type="checkbox" name="ads_id_title" /></td>
 </tr>
 <tr>
 <td><?_e('Allow to specify the lifetime of ad','ads-wordpress','ads-wordpress')?></td>
 <td><input type="checkbox" name="ads_set_lifetime" /> <?_e('count days','ads-wordpress')?></td>
 </tr>
 <tr>
 <td><?_e('Who can write messages','ads-wordpress')?></td>
 <td><select name="ads_user_status" size="1">
    <option value="0" ><?_e('everything','ads-wordpress')?></option>
    <option value="1"><?_e('registered','ads-wordpress')?></option>
    </select></td>
 </tr>

 <tr><td><?_e('Email notification','ads-wordpress')?></td>
 <td><input type="checkbox" name="ads_email_new_post" /><?_e('new post','ads-wordpress')?>&nbsp;&nbsp;&nbsp;
<input type="checkbox" name="ads_email_edit_post" /><?_e('post edit','ads-wordpress')?>&nbsp;&nbsp;&nbsp;
</td>
</tr>

 <tr>
 <td><font color="red">*</font><?_e('redirect link "Edit this entry" to the editor plug-in (add a filter to get_edit_post_link ())','ads-wordpress')?></td>
 <td> <input name="ads_edit_page" /><?_e('set page_id edit page','ads-wordpress')?></td>
 </tr>
<tr>
 <td><font color="red">*</font><?_e('include ads_queryfilter - search meta fields ','ads-wordpress')?></td>
 <td> <input type="checkbox" name="ads_queryfilter" /></td>
 </tr>

 <tr>
 <td><?_e('Enable user tags','ads-wordpress')?></td>
 <td><input type="checkbox" name="ads_user_tags" /></td>
 </tr>
 <tr>
 <td><?_e('Strip html tags','ads-wordpress')?><br />
 <?_e('this rule applies generally to the array $ _REQUEST','ads-wordpress')?></td>
 <td><input name="ads_strip_tags" />allowable tags, exemple:  &lt;a&gt;&lt;p&gt;&lt;b&gt;</td>
 </tr>
 <tr>
 <td><?_e('Disable Strip html tags','ads-wordpress')?></td>
 <td><input type="checkbox" name="ads_nostrip_tags" /></td>
 </tr>
<!--  <tr>
 <td><?_e('After saving the record only print a short message to an edit form does not print','ads-wordpress')?></td>
 <td><input type="checkbox" name="ads_short_message" /></td>
 </tr> -->

</tbody>
</table>
<p class="submit">
<input type="submit" name="Submit" value="<?php _e('Update Options', 'mt_trans_domain' ,'ads-wordpress') ?>" />
</p>

</form>
</div>
<?php
		$code = ob_get_contents();
		ob_end_clean();
		include_once dirname(__FILE__).'/FormPersister.php';
		$ob = new HTML_FormPersister();
		$proc = $ob->process($code);
		echo  $proc;

/*        if($ads_options['ads_set_lifetime'])
            wp_schedule_event(time(), 'hourly', 'ads_delete_gs'); */

}

add_action('admin_menu', 'admin_menu_add_pages');



function ads_template_apply($the_content){
    global $user_ID, $id, $ads_config,$ads_options, $post;
    if( !$post->meta['ads_basecat'] )return $the_content;
    $post_templates = $ads_config['post_templates'];
    extract($ads_options,EXTR_OVERWRITE);
    $arr_post = get_object_vars($post);
    unset($arr_post['files']);
    unset($arr_post['meta']);
	extract($arr_post, EXTR_OVERWRITE);
	extract($post->meta, EXTR_OVERWRITE);
    $post_content =  $the_content;
    $files =&$post->files;

 	// I dl the template post

    if( isset($post_templates[(int)$ads_basecat]) ){
        $template = $post_templates[(int)$ads_basecat];
    } else {
        $category = get_category($ads_basecat);
        if( isset($post_templates[$category->slug]) ) $template = $post_templates[$category->slug];
    	elseif( isset($post_templates[$category->name]) ) $template = $post_templates[$category->name];
    	else  $template = $post_templates['default'];
    }
	ob_start();
	include($ads_config['dir_template'].$template);
	$post_content = ob_get_contents();
	ob_end_clean();
	return $post_content;
}

function ads_addImgMeta($posts, $forcibly = 0){
   global $wpdb, $wp_query, $paged;
   if(!sizeof($posts)) return $posts;
   if(!$forcibly){
       foreach ($posts as $key=>$value) {
            if( $wp_query->posts[$key] !== $value ){
                return  $posts;
            }
       }
       if($posts[0]->meta  OR (is_admin() or is_page()) ){
           remove_filter('posts_results', 'ads_addImgMeta');

    	   return  $posts;
       }
   }

   $ar_post_id = array();
   foreach ($posts as $key => $post) {
        $ar_post_id[] = $post->ID;
        $ar_link[$post->ID] = & $posts[$key];
   }

   $st_id = @implode("','", $ar_post_id);
   //We obtain the first atachmenty
   $my_wpdb = new wpdb(DB_USER, DB_PASSWORD, DB_NAME, DB_HOST);
   // коректируем  found_posts  запоминаем его в глоб переменую и возвращаем через фильтр found_posts
   global $ads_found_rows;
   $ads_found_rows = $wpdb->get_var( 'SELECT FOUND_ROWS()' );
   add_filter('found_posts','ads_found_rows');
   $query = "SELECT $wpdb->posts.* FROM $wpdb->posts WHERE  $wpdb->posts.post_parent IN('$st_id') AND $wpdb->posts.post_parent
   AND $wpdb->posts.post_type = 'attachment'";

   $my_wpdb = new wpdb(DB_USER, DB_PASSWORD, DB_NAME, DB_HOST);
   $files = $my_wpdb->get_results($query);
   // obtain the list id atachmentov
   $ar_file_id = array();

   foreach ($files as $key=>$file) {
      $ar_file_id[] =  $file->ID;
      $ar_link[$file->ID] = & $files[$key];
   }

   // add up, we obtain a general list
   $ar_all_id = @array_merge($ar_post_id,$ar_file_id);


   $all_meta = update_meta_cache('post', $ar_all_id);
   if(!sizeof($all_meta))return $posts;
   // now clings meta Dane to posts
   $uploads_dir = wp_upload_dir('baseurl');
   foreach ($all_meta as $post_id=>$meta) {

       foreach($meta as $meta_key=>$value){
           $meta_value = maybe_unserialize($value[0]);

            if('_wp_attachment_metadata' == $meta_key AND sizeof($meta_value) ){

              $imgUrl = strstr ($meta_value['file'], '/wp-content');
              if(!$imgUrl){
                $imgUrl = $uploads_dir['baseurl'].'/'. $meta_value['file'];
              }
              $dirname = dirname($imgUrl);

              if($meta_value['sizes']){

                  $thumbUrl =  $dirname.'/'.$meta_value['sizes']['thumbnail']['file'];
                  if($meta_value['sizes']['medium'])
                    $mediumUrl =  $dirname.'/'.$meta_value['sizes']['medium']['file'];
                  else
                    $mediumUrl =  $imgUrl;
              }elseif($meta_value['thumb']){
                  $thumbUrl =  $dirname.'/'.$meta_value['thumb'];
                  $mediumUrl =  $dirname.'/'.$meta_value['thumb'];
              }else{
                 $mediumUrl = $thumbUrl =  $imgUrl;
              }

              $ar_link[$post_id]->thumbnail = $thumbUrl;
              $ar_link[$post_id]->medium = $mediumUrl;
              $ar_link[$post_id]->full = $imgUrl;
          }
          elseif('_wp_attached_file'==$meta_key){
          	  	$ar_link[$post_id]->attachment_url = $uploads_dir['baseurl'].'/'.$meta_value;
                $ar_link[$post_id]->thumbnail = $ar_link[$post_id]->medium = $ar_link[$post_id]->full = wp_mime_type_icon($post_id );
          }
          $ar_link[$post_id]->meta[$meta_key] = $meta_value;
          $meta_value = ''; $thumbUrl = ''; $mediumUrl = '';


       }


       //$meta_value = maybe_unserialize($row->meta_value);
      //'thumbnail' | 'medium' |

   }
   //  now clings atachmenty to posts

   usort ($files,'ads_sort_order');
   foreach ($files as $row) {
       if($row->menu_order == 0)
        $ar_link[$row->post_parent]->files[] = $row;
       else
        $ar_link[$row->post_parent]->files[$row->menu_order] = $row;
   }
   remove_filter('posts_results', 'ads_addImgMeta');
   return $posts;
}

function ads_sort_order($a,$b){
   return ($a->menu_order < $b->menu_order) ? -1 : 1;
}

function ads_found_rows ($found_rows){
    global $ads_found_rows;
    remove_filter('found_posts', 'ads_found_rows');
    return  $ads_found_rows;
};

if($ads_options['ads_template_apply']){
  add_filter('posts_results', 'ads_addImgMeta');
  add_filter('the_content', 'ads_template_apply',100);
}



// автоанонс текста
function ads_auto_more($posts) {
	if (is_single() || is_page() || is_feed()) return $posts;
	global $ads_options;
    $offset = ($ads_options['ads_count_str_more']) ? $ads_options['ads_count_str_more'] : 240;
    if( $offset<10) $offset = $offset*100;

    for ($i=0;$i<count($posts);$i++) {
     	if(!(($posts[$i]->post_type == 'post') OR ($posts[$i]->post_type == 'page'))) continue;
        if($posts[$i]->meta)$ads_basecat = $posts[$i]->meta['ads_basecat'];
        else $ads_basecat = get_post_meta($posts[$i]->ID, 'ads_basecat');
        if( !$ads_basecat ) continue;

    	if ($posts[$i]->post_excerpt) {
    		$posts[$i]->post_content = $posts[$i]->post_excerpt."<!--more-->";
    	}
    	else {
          $posts[$i]->post_content = ads_more( $posts[$i]->post_content, $offset);
          $posts[$i]->post_content .= "<!--more-->";
        }
  }
  return $posts;
}

if($ads_options['ads_auto_more']) add_filter('the_posts', 'ads_auto_more', 1);


function ads_id_title($title){
	global $id, $post;
	if(trim($title) != trim($post->post_title)) return $title;
	$ads_basecat = get_post_meta($id, 'ads_basecat');
	if( $ads_basecat[0] )
		return '№'.$id.' '.$title;
	else
		return $title;
}
if($ads_options['ads_id_title']) add_filter('the_title', 'ads_id_title');

/*
поиск по полям ads_  и adp_   полям
пример получить url поле где (adp_myvar > 12 )  и отсортировать по adp_myvar по возрастанию
$url = add_query_arg(array('adp_myvar[moe]'=>'12', 'ads_order[adp_myvar]'=>'asc'  ) );
*/
if($ads_options['ads_queryfilter'] AND !function_exists('ads_queryfilter')){

function array_empty($mixed) {
    if (is_array($mixed)) {
        foreach ($mixed as $value) {
            if (!array_empty($value)) {
                return false;
            }
        }
    }
    elseif ($mixed !== '') {
        return false;
    }
    return true;
}

function ads_queryfilter($query)
{
    global $wp_query, $wpdb;
    if($query !== $wp_query->request) return $query;
    if(!(is_category() OR is_homepage OR is_tags) OR is_page() OR isset($_REQUEST['ads_basecat']) ) return $query;
    $arrMetaVar = array();
    foreach ($_REQUEST as $key=>$value) {
        if(preg_match('~^ad(s|p)_+~',$key) AND $key != 'ads_basecat' AND !array_empty($value)){
            $arrMetaVar[$key] = urldecode_deep($value);
        }
    }

    // No variables starting with ads_ exit

    if(!sizeof($arrMetaVar)) return  $query;
    //    сортировка
    if(sizeof($arrMetaVar['ads_order'])){
        foreach ($arrMetaVar['ads_order']  as $key => $value){
             if(empty($value)) continue;
             $ads_order[$key]  =  $value;
        }
        $str_order ='';
        foreach ($ads_order as $key=>$value) {

            if(preg_match('~^ads_+~',$key)) {  // работаем с метаполями
                $sqlNameVar =  "$key.meta_value";
            }
            elseif( preg_match('~^adp_+~',$key) ){  // работаем напрямую с таблицей wp_post adp_  поля
                $sqlNameVar =  $key;
            }
            if($value == 'desc') {
                  $ads_order[$key] = " $sqlNameVar DESC";
            }elseif($value == 'idesc') {
                  $ads_order[$key] = " $sqlNameVar+0 DESC";
            }elseif($value == 'iasc') {
                  $ads_order[$key] = " $sqlNameVar+0 ASC";
            }else{
                  $ads_order[$key] = " $sqlNameVar ASC";
            }
            if(!isset($arrMetaVar[$key]))$arrMetaVar[$key]['join'] = '';
        }
        $str_order = implode(', ', $ads_order);
        unset ($arrMetaVar['ads_order']);
    }


    foreach ($arrMetaVar as $key=>$value) {
        $value =  stripslashes_deep($value);
        $key = stripslashes( $key);
        if(preg_match('~^ads_+~',$key)) {  // работаем с метаполями
            $str_JOIN .= "\n LEFT JOIN $wpdb->postmeta $key ON ($wpdb->posts.ID = $key.post_id)";
            $str_AND_key .= "\n AND $key.meta_key = '$key' ";
            $sqlNameVar =  "$key.meta_value";
        }
        elseif( preg_match('~^adp_+~',$key) ){  // работаем напрямую с таблицей wp_post adp_  поля
            $sqlNameVar =  $key;
        }
        if( function_exists($key.'_query') ){
           $str_AND_logical .= call_user_func ($key.'_query', $value);
        }elseif( is_array($value) ){
            //$opereator = key($value);
            foreach ($value  as $opereator => $vvalue){
             switch ($opereator) {
                case 'more':   //more less
                    $str_AND_logical .= "AND $sqlNameVar > ".$vvalue."\n";
                break;
                case 'less':
                    $str_AND_logical .= "AND $sqlNameVar < ".$vvalue."\n";
                break;
                case 'moe':  // more or equal
                    $str_AND_logical .= "AND $sqlNameVar >= ".$vvalue."\n";
                break;
                case 'loe': // less or equal
                    $str_AND_logical .= "AND $sqlNameVar <= ".$vvalue."\n";
                break;
                case 'ne':  //not equal
                    $str_AND_logical .= "AND $sqlNameVar != ".$vvalue."\n";
                break;
                case 'isnull':  //not equal
                    $str_AND_logical .= "AND ISNULL($sqlNameVar) \n";
                break;
                case 'notnull':  //not equal
                    $str_AND_logical .= "AND NOT ISNULL($sqlNameVar)\n";
                break;

                case 'between':
                    if( ($vvalue[0] === '') AND ($vvalue[1] === '') )
                        break;
                    elseif( ($vvalue[0] === '') AND ($vvalue[1] !== '') )
                         $str_AND_logical .= "AND $sqlNameVar <= ".$vvalue[1]."\n";

                    elseif( ($vvalue[0] !== '') AND ($vvalue[1] === '') )
                        $str_AND_logical .= "AND $sqlNameVar >= ".$vvalue[0]."\n";
                    else
                        $str_AND_logical .= "AND $sqlNameVar BETWEEN ".$vvalue[0].' AND '.$vvalue[1]." \n";

                break;
                case 'in':
                   $many = implode("', '",$value[$opereator] );
                    $str_AND_logical .= "AND $sqlNameVar IN ( '$many' ) \n";
                break;
                case 'rlike':
                    $str_AND_logical .= "AND $sqlNameVar rlike '".$value[$opereator]."'\n";
                break;
                case 'join':
                break;
                default:
                break;
            }

            }

        }else{
            $str_AND_logical .= "AND $sqlNameVar LIKE '%$value%' \n";
        }
     }
     $str_AND = $str_AND_key ."\n".$str_AND_logical;

    $query = str_replace('WHERE', $str_JOIN."\n WHERE",$query);

    if(strstr($query,'GROUP BY')){
        $query = str_replace('GROUP BY', $str_AND.'GROUP BY',$query);
    } else{
       $query = str_replace('ORDER BY', $str_AND.'ORDER BY',$query);
    }

    if($str_order){
        $query = str_replace('ORDER BY', 'ORDER BY '.$str_order.', ', $query);
    }
    remove_filter('posts_request', 'ads_queryfilter');
    $query = preg_replace('~AND 0 = 1 ~', '', $query);
    //echo '<pre>';print_r($query);echo '</pre>';
    return $query;
}

function urldecode_deep($value){
	$value = is_array($value) ? array_map('urldecode_deep', $value) : urldecode($value);
	return $value;}

add_filter('posts_request', 'ads_queryfilter');
}


//  исключаем рубрику ads_location везде получить выборку по ней можно только если
// указать  ее  в child_of
function ads_location_root($exclusions,$args){
    global $ads_options;
    if(is_admin()) return $exclusions;

    if($args['child_of'] == $ads_options['ads_location_root']) return  $exclusions;
	if( !(($args['type'] == 'category') OR ($args['taxonomy'] == 'category')) ) return $exclusions;
	$excluded_children = (array) get_terms('category', array('child_of' => intval($ads_options['ads_location_root']), 'fields' => 'ids'));
	$excluded_children[] = $ads_options['ads_location_root'];

	foreach( (array) $excluded_children as $exterm ) {
                $exl[] = ' t.term_id != ' . intval($exterm) . ' ';
	}
	$exclusions = $exclusions .' AND ('. implode(' AND ',$exl) .')';
    return $exclusions;
}
if($ads_options['ads_location_root']){
   add_filter('list_terms_exclusions', 'ads_location_root', 10, 2);
}


/*Array
(
    [comment_post_ID] => 945
    [comment_author] => qwrfqwe
    [comment_author_email] => sadf@ewr.com.ua
    [comment_author_url] => http://adsgfasdfasd
    [comment_content] => zds выап sdfg sdfg
    [comment_type] =>
    [user_ID] =>
)
notification comments
*/
function ads_send_email($comment_id){
    global $commentdata;
    $post_email = get_post_meta($commentdata['comment_post_ID'], 'ads_email', ture);
    if(!$post_email) return;
    $post_url = get_permalink($commentdata['comment_post_ID'] );
    $autor = $commentdata['comment_author'];
	/* recipients */
	$to = $post_email;
	$headers  = "MIME-Version: 1.0\n";
	$headers .= "Content-type: text/txt; charset=utf-8\n";
	/* тема\subject */
	$subject = __("Comment to the announcement on ",'ads-wordpress').get_bloginfo('url') ;
	$message .=	__('From ','ads-wordpress').$autor.__(' We obtain a new comment to your ad: ','ads-wordpress').$post_url;

	mail($to, $subject, $message, $headers);

}
if($ads_options['ads_comments_ping']){
    add_action('comment_post', 'ads_send_email');
}

//  гребаное расписание

register_activation_hook(__FILE__, 'ads_activation');
add_action('ads_hourly_event', 'ads_this_hourly');

function ads_activation() {
	wp_schedule_event(time(), 'hourly', 'ads_hourly_event');
	wp_clear_scheduled_hook('ads_delete_gs');
}
function ads_this_hourly() {
	// do something every hour
   global  $wpdb;  //$wpdb->postmeta.meta_value < NOW() || DATE_ADD($wpdb->posts.post_date,  INTERVAL $wpdb->postmeta.meta_value DAY)
$wp_curtime =  current_time('timestamp');
$time = time();
   $query = "SELECT $wpdb->postmeta.*, $wpdb->posts.post_modified,$wpdb->posts.post_modified_gmt,
   (unix_timestamp($wpdb->posts.post_modified)+($wpdb->postmeta.meta_value*24*3600) - $time ) AS post_ded,
unix_timestamp($wpdb->posts.post_modified) AS post_mod,
($wpdb->postmeta.meta_value*24*3600) AS meta_value_s,
$wp_curtime AS now
 FROM $wpdb->postmeta  LEFT JOIN  $wpdb->posts ON ($wpdb->posts.ID = $wpdb->postmeta.post_id) WHERE $wpdb->postmeta.meta_key = 'ads_lifetime'
AND (unix_timestamp($wpdb->posts.post_modified)+($wpdb->postmeta.meta_value*24*3600) - $time )<0
ORDER BY post_ded ASC LIMIT 30";
   $recent_post = $wpdb->get_results($query);
   foreach ($recent_post as $key=>$value) {
        $arrTmp = get_children(array('numberposts'=>-1, 'post_type'=>'attachment','post_status'=>'inherit', 'post_parent'=>$value->post_id));
		$arrTmp[$value->post_id] = '';
		foreach ($arrTmp as $key=>$value) {
  			$post = wp_delete_post($key,1);
  			$title = ($post->post_title)?$post->post_title:$post->post_name;
        }
    }

    // удаляем все также просроченные черновики за  21 суток
    $query = "SELECT ID FROM `$wpdb->posts` LEFT JOIN `$wpdb->postmeta` ON ($wpdb->postmeta.post_id = $wpdb->posts.ID)
WHERE $wpdb->posts.post_status = 'draft'  AND (NOW() - unix_timestamp($wpdb->posts.post_date) ) > 1814400  AND  $wpdb->postmeta.meta_key = 'ads_basecat'";
    $recent_post = $wpdb->get_results($query);
    foreach ($recent_post as $key=>$value) {
        $arrTmp = get_children(array('numberposts'=>-1, 'post_type'=>'attachment','post_status'=>'inherit', 'post_parent'=>$value->ID));
		$arrTmp[$value->ID] = '';
		foreach ($arrTmp as $key=>$value) {
  			$post = wp_delete_post($key,1);
  			$title = ($post->post_title)?$post->post_title:$post->post_name;
        }
    }

        // зачищаем потерянные метаполя
    $query = "SELECT $wpdb->postmeta.meta_id, $wpdb->postmeta.post_id, $wpdb->postmeta.meta_key FROM $wpdb->postmeta
                LEFT OUTER JOIN `$wpdb->posts` ON ( $wpdb->postmeta.post_id = $wpdb->posts.ID ) WHERE $wpdb->posts.ID IS NULL";
    $recent_post = $wpdb->get_results($query);
    foreach ($recent_post as $key=>$value){
       delete_post_meta($value->post_id, $value->meta_key);
    }

    if( function_exists('ads_pay_cron') ){
       ads_pay_cron();
    }


}
register_deactivation_hook(__FILE__, 'ads_deactivation');

function ads_deactivation() {
	wp_clear_scheduled_hook('ads_hourly_event');

}
?>