<?php
/*
	Widget - recent ads
*/

class Ads_Recent_Ads extends WP_Widget {
	function Ads_Recent_Ads() {
		// widget actual processes
		 parent::WP_Widget(false, $name = 'Ads_Recent_Ads');	
	}

    function form($instance) {				
            $title = esc_attr($instance['title']);
            $numberposts  =  esc_attr($instance['numberposts']);
            $title_length  =  esc_attr($instance['title_length']);
            $category = esc_attr($instance['category']);
            $image = esc_attr($instance['image']);
            $meta_key = esc_attr($instance['meta_key']);
            $add_link = esc_attr($instance['add_link']);
            ?>
                <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
                <p><label for="<?php echo $this->get_field_id('numberposts'); ?>"><?php _e('Number posts:','ads-wordpress'); ?> <input class="widefat" id="<?php echo $this->get_field_id('numberposts'); ?>" name="<?php echo $this->get_field_name('numberposts'); ?>" type="text" value="<?php echo $numberposts; ?>" /></label></p>
                <p><label for="<?php echo $this->get_field_id('title_length'); ?>"><?php _e('Title length:','ads-wordpress'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title_length'); ?>" name="<?php echo $this->get_field_name('title_length'); ?>" type="text" value="<?php echo $title_length; ?>" /></label></p>
                <p><label for="<?php echo $this->get_field_id('category'); ?>"><?php _e('Categories:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('category'); ?>" name="<?php echo $this->get_field_name('category'); ?>" type="text" value="<?php echo $category; ?>" /></label>
<span style="font-size:0.8em"><? _e('Example: 12,4,5','ads-wordpress');?></span>
</p>            <p><label for="<?php echo $this->get_field_id('add_link'); ?>"><?php _e('Add link:','ads-wordpress'); ?> <input class="widefat" id="<?php echo $this->get_field_id('add_link'); ?>" name="<?php echo $this->get_field_name('add_link'); ?>" type="text" value="<?php echo $add_link; ?>" /></label>
<span style="font-size:0.8em"><? _e('ID page with a form of Add','ads-wordpress');?></span>
</p>
                
<p><label for="<?php echo $this->get_field_id('image'); ?>"><?php _e('Only with image:','ads-wordpress'); ?> <input class="widefat" id="<?php echo $this->get_field_id('image'); ?>" name="<?php echo $this->get_field_name('image'); ?>" type="text" value="<?php echo $image; ?>" /></label>
<span style="font-size:0.8em"><? _e('Specify the size of the example: 80x80','ads-wordpress');?></span>
</p>
                
                <p><label for="<?php echo $this->get_field_id('meta_key'); ?>"><?php _e('Meta field name:','ads-wordpress'); ?> <input class="widefat" id="<?php echo $this->get_field_id('meta_key'); ?>" name="<?php echo $this->get_field_name('meta_key'); ?>" type="text" value="<?php echo $meta_key; ?>" /></label>
<span style="font-size:0.8em"><? _e('Containing the specified metadata field','ads-wordpress');?></span>
                </p>
                                
            <?php 
    }


	function update($new_instance, $old_instance) {
		// processes widget options to be saved
		return $new_instance;
	}

    function widget($args, $instance) {	
        extract( $args );
        if($instance['category']){
            $instance['category'] = explode(',',$instance['category']);
        }
        if($instance['image']){
            list($width,$height) = explode('x',$instance['image']);
        }
        $recent = ads_recent($instance);
        if(!sizeof($recent)) return;
        $title = apply_filters('widget_title', $instance['title']);
        echo $before_widget;
        if ( $title )
               echo $before_title . $title . $after_title;
        echo "\n<ul class='ads_recent_widget'>\n";

        foreach ($recent as $key=>$ads) {
            $out = "\n<li><a href='".get_permalink($ads->ID)."'>\n";
            if($width){       
                $out .= "<img src='".wp_get_attachment_thumb_url($ads->image)."' width='{$width}px' height='{$height}px' />";
            }
            //If you set metafields then it can be concluded here
            //$out .= $ads->meta;
            $out .= ($instance['title_length'])? ads_more($ads->post_title,$instance['title_length']) :  $ads->post_title;
            $out .='</a></li>';
            echo $out;	
        }                
        echo "\n</ul>\n";
        if($instance['add_link']){
            $add_url = get_permalink($instance['add_link']);
            $add_page = get_page($instance['add_link']);
            echo "<a href='$add_url' id='add_link' >$add_page->post_title</a>";
        }
        echo $after_widget; 
    }
}
add_action('widgets_init', create_function('', 'return register_widget("Ads_Recent_Ads");'));

?>
